<?php

/*
 * AfterLogic Admin Panel by AfterLogic Corp. <support@afterlogic.com>
 *
 * Copyright (C) 2002-2009  AfterLogic Corp. (www.afterlogic.com)
 * Distributed under the terms of the license described in LICENSE.txt
 * 
 */

	class CWebMail_Plugin extends ap_Plugin
	{
		/**
		 * @var	WebMail_Settings
		 */
		var $_settings;
		
		var $_db;
		
		/**
		 * @var	bool
		 */
		var $_isConnect = false;
		
		/**
		 * @var	bool
		 */
		var $_isLoad = true;
		
		/**
		 * @var	array
		 */
		var $Tabs = array(
			array('WebMail', 'WebMail Settings', 'wm'),
			array('Domains', 'WebMail Domains', 'domains'),
			array('Users', 'WebMail Users', 'users')
		);
		
		/**
		 * @var int
		 */
		var $_ptype = AP_P;
		
		/**
		 * @var	bool
		 */
		var $_useDbCreate = false;
		
		/**
		 * @param	string	$_tab
		 * @return	string|false
		 */
		function GetScreenName($_tab)
		{
			$_return = false;
			switch ($_tab)
			{
				case 'wm':
					$_return = 'ap_Screen_Standard';
					break;
				case 'users':
				case 'domains':
					$_return = 'ap_Screen_Tables';
					break;
			}
			
			return $_return;
		}
		
		/**
		 * @param	array	$_cfg
		 * @return	true|string
		 */
		function ValidateCfg($_cfg)
		{
			if (!isset($_cfg['webmail_web_path']))
			{
				return 'Path to WebMail web folder should be specified in "'.AP_CFG_FILE.'" config file.';
			}
		
			if (!file_exists($_cfg['webmail_web_path'].'/inc_settings_path.php'))
			{
				return 'Path to WebMail web folder is incorrect as "inc_settings_path.php" file is not found.';
			}

			return true;
		}
		
		/**
		 * @return	string
		 */
		function WriteAction()
		{
			$_ref = null;
			$_errorDesc = $_infoDesc = '';
			$_saveSettings = true;
			
			if (!$this->_isLoad)
			{
				$this->_setError(ap_Utils::TakePhrase('WM_INFO_CANTLOAD_SETTINGS'));
				return $_ref;
			}
			
			if (isset($_POST['form_id']) && strlen($_POST['form_id']) > 0)
			{
				switch ($_POST['form_id'])
				{
					case 'db':
						
						if (isset($_POST['intDbType']))
						{
							switch ($_POST['intDbType'])
							{
								case WM_DB_MSSQLSERVER:
								case WM_DB_MYSQL:
									$this->_settings->DbType = (int) $_POST['intDbType'];
									break;
								default:
									$this->_settings->DbType = WM_DB_MYSQL;
									break;
							}
						}
						
						$this->_settings->DbLogin = isset($_POST['txtSqlLogin']) ? $_POST['txtSqlLogin'] : $this->_settings->DbLogin;
						if (isset($_POST['txtSqlPassword']))
						{
							if ($_POST['txtSqlPassword'] != AP_DUMMYPASSWORD)
							{
								$this->_settings->DbPassword = $_POST['txtSqlPassword'];
							}
						}
						$this->_settings->DbName = isset($_POST['txtSqlName']) ? $_POST['txtSqlName'] : $this->_settings->DbName;
						$this->_settings->DbDsn = isset($_POST['txtSqlDsn']) ? $_POST['txtSqlDsn'] : $this->_settings->DbDsn;
						$this->_settings->DbHost = isset($_POST['txtSqlSrc']) ? $_POST['txtSqlSrc'] : $this->_settings->DbHost;
						
						$this->_settings->DbCustomConnectionString = isset($_POST['odbcConnectionString']) ? $_POST['odbcConnectionString'] : $this->_settings->DbCustomConnectionString;
						$this->_settings->UseCustomConnectionString = (isset($_POST['useCS']) && $_POST['useCS'] == 1);
						
						if (isset($_POST['test_connection']))
						{
							include $this->PluginPath().'/common/db/class_dbsql.php';
							include $this->PluginPath().'/common/db/dbstorage.php';

							$_db =& DbStorageCreator::CreateDatabaseStorage($this->_settings);
							
							$_start = ap_Utils::Microtime();
							if ($_db->Connect())
							{ 
								$_infoDesc = ap_Utils::TakePhrase('WM_INFO_CONNECTSUCCESSFUL').' ('.substr((ap_Utils::Microtime() - $_start), 0, 6).' sec)';
								@$_db->Disconnect();
							}
							else
							{
								$_dberror = $_db->GetError();
								$_dberror = strlen($_dberror) > 5 ? AP_HTML_BR.$_dberror : '';
								$_errorDesc = ap_Utils::TakePhrase('WM_INFO_CONNECTUNSUCCESSFUL').$_dberror;
							}
						}
						else if (isset($_POST['create_db']) && $this->_ap->IsEnable())
						{
							include $this->PluginPath().'/common/db/class_dbsql.php';
							include $this->PluginPath().'/common/db/dbstorage.php';

							$_db =& DbStorageCreator::CreateDatabaseStorage($this->_settings);
							
							if ($_db->ConnectNoSelect())
							{
								if ($_db->CreateDatabase($this->_settings->DbName))
								{
									$_infoDesc = ap_Utils::TakePhrase('WM_INFO_DBCREATESUCCESSFUL');		
								}
								else 
								{
									$_dberror = $_db->GetError();
									$_dberror = strlen($_dberror) > 5 ? AP_HTML_BR.$_dberror : '';
									$_errorDesc = ap_Utils::TakePhrase('WM_INFO_DBCREATEUNSUCCESSFUL').$_dberror;
								}
								
								@$_db->Disconnect();
							}
							else
							{
								$_dberror = $_db->GetError();
								$_dberror = strlen($_dberror) > 5 ? AP_HTML_BR.$_dberror : '';
								$_errorDesc = ap_Utils::TakePhrase('WM_INFO_CONNECTUNSUCCESSFUL').$_dberror;
							}
						}
						else if (isset($_POST['drop_db']) && $this->_ap->IsEnable())
						{
							include $this->PluginPath().'/common/db/class_dbsql.php';
							include $this->PluginPath().'/common/db/dbstorage.php';

							$_db =& DbStorageCreator::CreateDatabaseStorage($this->_settings);
							
							if ($_db->ConnectNoSelect())
							{
								if ($_db->DropDatabase($this->_settings->DbName))
								{
									$_infoDesc = ap_Utils::TakePhrase('WM_INFO_DBDROPSUCCESSFUL');		
								}
								else 
								{
									$_dberror = $_db->GetError();
									$_dberror = strlen($_dberror) > 5 ? AP_HTML_BR.$_dberror : '';
									$_errorDesc = ap_Utils::TakePhrase('WM_INFO_DBCDROPUNSUCCESSFUL').$_dberror;
								}
								
								@$_db->Disconnect();
							}
							else
							{
								$_dberror = $_db->GetError();
								$_dberror = strlen($_dberror) > 5 ? AP_HTML_BR.$_dberror : '';
								$_errorDesc = ap_Utils::TakePhrase('WM_INFO_CONNECTUNSUCCESSFUL').$_dberror;
							}
						}
					
						$_ref = '?mode='.WM_MODE_DB;
						break;
						
					case 'webmail':
						
						$this->_settings->WindowTitle = isset($_POST['txtSiteName']) ? $_POST['txtSiteName'] : $this->_settings->WindowTitle;
						$this->_settings->IncomingMailServer = isset($_POST['txtIncomingMail']) ? $_POST['txtIncomingMail'] : $this->_settings->IncomingMailServer;
						$this->_settings->IncomingMailPort = isset($_POST['intIncomingMailPort']) ? (int) $_POST['intIncomingMailPort'] : $this->_settings->IncomingMailPort;

						if (isset($_POST['intIncomingMailProtocol']))
						{
							switch ($_POST['intIncomingMailProtocol'])
							{
								case WM_MAILPROTOCOL_IMAP4:
								case WM_MAILPROTOCOL_POP3:
									$this->_settings->IncomingMailProtocol = (int) $_POST['intIncomingMailProtocol'];
									break;
								default:
									$this->_settings->IncomingMailProtocol = WM_MAILPROTOCOL_POP3;
									break;
							}
						}
						
						$this->_settings->OutgoingMailServer = isset($_POST['txtOutgoingMail']) ? $_POST['txtOutgoingMail'] : $this->_settings->OutgoingMailServer;
						$this->_settings->OutgoingMailPort = isset($_POST['intOutgoingMailPort']) ? (int) $_POST['intOutgoingMailPort'] : $this->_settings->OutgoingMailPort;
						
						$this->_settings->ReqSmtpAuth = (isset($_POST['intReqSmtpAuthentication']) && $_POST['intReqSmtpAuthentication'] == 1);
						$this->_settings->AllowDirectMode = (isset($_POST['intAllowDirectMode']) && $_POST['intAllowDirectMode'] == 1);
						$this->_settings->DirectModeIsDefault = (isset($_POST['intDirectModeIsDefault']) && $_POST['intDirectModeIsDefault'] == 1);
						
						if (isset($_POST['intAttachmentSizeLimit']) && strlen($_POST['intAttachmentSizeLimit']) < 7)
						{
							$this->_settings->AttachmentSizeLimit = (int) (((int) $_POST['intAttachmentSizeLimit']) * 1024);
						}
						$this->_settings->EnableAttachmentSizeLimit = (isset($_POST['intEnableAttachSizeLimit']) && $_POST['intEnableAttachSizeLimit'] == 1);						

						if (isset($_POST['intMailboxSizeLimit']) && strlen($_POST['intMailboxSizeLimit']) < 7)
						{
							$this->_settings->MailboxSizeLimit = (int) (((int) $_POST['intMailboxSizeLimit'])*1024);
						}
						$this->_settings->EnableMailboxSizeLimit = (isset($_POST['intEnableMailboxSizeLimit']) && $_POST['intEnableMailboxSizeLimit'] == 1);
						
						$this->_settings->AllowUsersChangeEmailSettings = (isset($_POST['intAllowUsersChangeEmailSettings']) && $_POST['intAllowUsersChangeEmailSettings'] == 1);
						$this->_settings->AllowNewUsersRegister = (isset($_POST['intAllowNewUsersRegister']) && $_POST['intAllowNewUsersRegister'] == 1);
						$this->_settings->AllowUsersAddNewAccounts = (isset($_POST['intAllowUsersAddNewAccounts']) && $_POST['intAllowUsersAddNewAccounts'] == 1);
						
						$this->_settings->DefaultUserCharset = isset($_POST['txtDefaultUserCharset']) ? $_POST['txtDefaultUserCharset'] : $this->_settings->DefaultUserCharset;
						$this->_settings->AllowUsersChangeCharset = (isset($_POST['intAllowUsersChangeCharset']) && $_POST['intAllowUsersChangeCharset'] == 1);						
						$this->_settings->DefaultTimeZone = isset($_POST['txtDefaultTimeZone']) ? $_POST['txtDefaultTimeZone'] : $this->_settings->DefaultTimeZone;
						$this->_settings->AllowUsersChangeTimeZone = (isset($_POST['intAllowUsersChangeTimeZone']) && $_POST['intAllowUsersChangeTimeZone'] == 1);
						
						$_ref = '?mode='.WM_MODE_WEBMAIL;
						break;
					
					case 'interface':
						
						$this->_settings->MailsPerPage = isset($_POST['intMailsPerPage']) ? (int) $_POST['intMailsPerPage'] : $this->_settings->MailsPerPage;
						$this->_settings->DefaultSkin = isset($_POST['txtDefaultSkin']) ? $_POST['txtDefaultSkin'] : $this->_settings->DefaultSkin;
						$this->_settings->AllowUsersChangeSkin = (isset($_POST['intAllowUsersChangeSkin']) && $_POST['intAllowUsersChangeSkin'] == 1);
						$this->_settings->DefaultLanguage = isset($_POST['txtDefaultLanguage']) ? $_POST['txtDefaultLanguage'] : $this->_settings->DefaultLanguage;
						$this->_settings->AllowUsersChangeLanguage = (isset($_POST['intAllowUsersChangeLanguage']) && $_POST['intAllowUsersChangeLanguage'] == 1);
						$this->_settings->ShowTextLabels = (isset($_POST['intShowTextLabels']) && $_POST['intShowTextLabels'] == 1);
						$this->_settings->AllowAjax = (isset($_POST['intAllowAjaxVersion']) && $_POST['intAllowAjaxVersion'] == 1);
						$this->_settings->AllowDhtmlEditor = (isset($_POST['intAllowDHTMLEditor']) && $_POST['intAllowDHTMLEditor'] == 1);
						$this->_settings->AllowContacts = (isset($_POST['intAllowContacts']) && $_POST['intAllowContacts'] == 1);
						$this->_settings->AllowCalendar = (isset($_POST['intAllowCalendar']) && $_POST['intAllowCalendar'] == 1);
						
						$_ref = '?mode='.WM_MODE_INTERFACE;
						break;

					case 'login':
						
						$this->_settings->AllowAdvancedLogin = (isset($_POST['intAllowAdvancedLogin']) && $_POST['intAllowAdvancedLogin'] == 1);
						$this->_settings->AutomaticCorrectLoginSettings = (isset($_POST['intAutomaticHideLogin']) && $_POST['intAutomaticHideLogin'] == 1);
						$this->_settings->DefaultDomainOptional = isset($_POST['txtUseDomain']) ? $_POST['txtUseDomain'] : $this->_settings->DefaultDomainOptional;
						
						$_hideLoginMode = 0;
						if (isset($_POST['hideLoginRadionButton']))
						{
							switch ($_POST['hideLoginRadionButton'])
							{
								case '0': break;
								case '1':
									$_hideLoginMode = 10;
									if (isset($_POST['hideLoginSelect']) && $_POST['hideLoginSelect'] == '1')
									{
										$_hideLoginMode++;
									}
									break;
								case '2':
									$_hideLoginMode = 20;
									if (isset($_POST['intDisplayDomainAfterLoginField']) && $_POST['intDisplayDomainAfterLoginField'] == 1) 
									{
										$_hideLoginMode++;
									}
									if (isset($_POST['intLoginAsConcatination']) && $_POST['intLoginAsConcatination'] == 1)
									{
										$_hideLoginMode = $_hideLoginMode + 2;
									}
									break;
							}
						}
						
						$this->_settings->HideLoginMode = $_hideLoginMode;
						
						$_ref = '?mode='.WM_MODE_LOGIN;
						break;
						
					case 'calendar':
						
						$this->_settings->Cal_DefaultTimeFormat = isset($_POST['defTimeFormat']) ? $_POST['defTimeFormat'] : $this->_settings->Cal_DefaultTimeFormat;
						$this->_settings->Cal_DefaultDateFormat = isset($_POST['defDateFormat']) ? $_POST['defDateFormat'] : $this->_settings->Cal_DefaultDateFormat;
						$this->_settings->Cal_ShowWeekends = ((isset($_POST['showWeekends']) && $_POST['showWeekends'] == 1) ? 1 : 0);
						$this->_settings->Cal_WorkdayStarts = isset($_POST['WorkdayStarts']) ? $_POST['WorkdayStarts'] : $this->_settings->Cal_WorkdayStarts;																
						$this->_settings->Cal_WorkdayEnds = isset($_POST['WorkdayEnds']) ? $_POST['WorkdayEnds'] : $this->_settings->Cal_WorkdayEnds;	
						$this->_settings->Cal_ShowWorkDay = ((isset($_POST['showWorkDay']) && $_POST['showWorkDay'] == 1) ? 1 : 0);
						$this->_settings->Cal_WeekStartsOn = isset($_POST['weekStartsOn']) ? $_POST['weekStartsOn'] : $this->_settings->Cal_WeekStartsOn;
						$this->_settings->Cal_DefaultTab = isset($_POST['defTab']) ? $_POST['defTab'] : $this->_settings->Cal_DefaultTab;
						$this->_settings->Cal_DefaultCountry = isset($_POST['defCountry']) ? $_POST['defCountry'] : $this->_settings->Cal_DefaultCountry;
						$this->_settings->Cal_DefaultTimeZone = isset($_POST['defTimeZone']) ? $_POST['defTimeZone'] : $this->_settings->Cal_DefaultTimeZone;																
						$this->_settings->Cal_AllTimeZones = ((isset($_POST['allTimeZones']) && $_POST['allTimeZones'] == 1)? 1 : 0);
						
						$_ref = '?mode='.WM_MODE_CAL;
						break;
					
					case 'debug':
						if (isset($_POST['submit_btn']))
						{
							$this->_settings->EnableLogging = (isset($_POST['intEnableLogging']) && $_POST['intEnableLogging'] == 1);
						}
						else
						{
							$_saveSettings = false;
							if (isset($_POST['txtPathForLog']))
							{
								if (file_exists($_POST['txtPathForLog']))
								{
									if (@unlink($_POST['txtPathForLog']))
									{
										$_infoDesc = ap_Utils::TakePhrase('WM_INFO_LOGCLEARSUCCESSFUL');
									}
									else
									{
										$_errorDesc = ap_Utils::TakePhrase('WM_INFO_ERROR');
									}
								}
								else
								{
									$_infoDesc = ap_Utils::TakePhrase('WM_INFO_LOGCLEARSUCCESSFUL');
								}
							}
							else
							{
								$_errorDesc = ap_Utils::TakePhrase('WM_INFO_ERROR');
							}
						}
						$_ref = '?mode='.WM_MODE_DEBUG;
						break;
						
					case 'integr':
						
						include_once $this->_pluginInfo->Path.'/common/libs/class_xmail.php';
						
						if (!$this->_settings->EnableWmServer && $this->_settings->IncomingMailProtocol == WM_MAILPROTOCOL_WMSERVER)
						{
							$this->_settings->IncomingMailProtocol = WM_MAILPROTOCOL_POP3;
						}
					
						$this->_settings->WmServerRootPath = isset($_POST['txtWmServerRootPath']) ? ap_Utils::PathPreparation($_POST['txtWmServerRootPath']) : $this->_settings->WmServerRootPath;
						$this->_settings->WmServerHost = isset($_POST['txtWmServerHostName']) ? $_POST['txtWmServerHostName'] : $this->_settings->WmServerHost; 
						$this->_settings->WmAllowManageXMailAccounts = (isset($_POST['intWmAllowManageXMailAccounts']) && $_POST['intWmAllowManageXMailAccounts'] == 1);
						
						if ($this->_settings->EnableWmServer)
						{
							if (isset($_POST['txtWmServerRootPath']))
							{
								$_rootPath = ap_Utils::PathPreparation($_POST['txtWmServerRootPath']);
								if (strlen($_rootPath) > 1)
								{
									if (!is_dir($_rootPath.'/domains'))
									{
										$_errorDesc = ap_Utils::TakePhrase('WM_INFO_ROOTPATHINCORRECT');
									}
									elseif (!file_exists($_rootPath.'/'.WM_WEBMAILCONFIGTAB))
									{
										$_errorDesc = ap_Utils::TakePhrase('WM_INFO_CANTFIND').WM_WEBMAILCONFIGTAB;
									}
								}
								else 
								{
									$_errorDesc = ap_Utils::TakePhrase('WM_INFO_ROOTPATHINCORRECT');
								}
							}
							else
							{
								$_errorDesc = ap_Utils::TakePhrase('WM_INFO_ROOTPATHINCORRECT');
							}
							
							if (!isset($_POST['txtWmServerHostName']) || strlen(trim($_POST['txtWmServerHostName'])) == 0)
							{
								$_errorDesc = ap_Utils::TakePhrase('WM_INFO_CONNECTUNSUCCESSFUL');
							}
							
							if (strlen($_errorDesc) == 0)
							{					
								$_WMServer = new CWmServerConsoleAdm($this->_settings, $_POST['txtWmServerHostName']);
								if ($_WMServer)
								{
									$_req = $_WMServer->Connect();
									if (true !== $_req)
									{
										$_errorDesc = ap_Utils::TakePhrase('WM_INFO_CONNECTUNSUCCESSFUL').AP_HTML_BR.str_replace(array("\r", "\t", "\n"), ' ', $_WMServer->GetError());
									}
									else
									{
										$_WMServer->Disconnect();
									}
								}
								else
								{
									$_errorDesc = ap_Utils::TakePhrase('WM_INFO_ERROR');
								}
							}
							
						}
						$_ref = '?mode='.WM_MODE_INTEGRATION;
						break;
				}
			}
			else if (isset($_POST['mode_name']) && strlen($_POST['mode_name']) > 0)
			{
				$_saveSettings = false;

				if ($this->Connect())
				{
					if ($this->_ap->Tab() == 'domains')
					{
						switch ($_POST['mode_name'])
						{
							case 'collection':
								if (isset($_POST['chCollection']) && count($_POST['chCollection']) > 0)
								{
									$_domains_for_delete = array();
									foreach ($_POST['chCollection'] as $_value)
									{
										$_expl = explode(AP_UIDS_DELIMITER, $_value);
										if (is_array($_expl))
										{
											foreach ($_expl as $_item)
											{
												$_arr = ap_Utils::UidExplode($_item);
												if ($_arr[0] == AP_TYPE_WEBMAIL)
												{
													$_domains_for_delete[] = (int) $_arr[1];
												}				
											}
										}
									}
	
									if (count($_domains_for_delete) > 0)
									{
										if ($this->_db->DeleteDomainsByIds($_domains_for_delete))
										{
											$_infoDesc = ap_Utils::TakePhrase('WM_DELETE_SUCCESSFUL');
										}
										else
										{
											$_errorDesc = ap_Utils::TakePhrase('WM_DELETE_UNSUCCESSFUL');
										}
									}
								}
								
								break;
	
							case 'new':
								if (isset($_POST['switchElement']))
								{
									switch ($_POST['switchElement'])
									{
										case 'ext':
											if (isset($_POST['textDomainName']) && strlen($_POST['textDomainName']) > 0)
											{
												$_POST['textDomainName'] = strtolower($_POST['textDomainName']);
												include_once $this->PluginPath().'/common/class_domains.php';
												
												$_domain = new CWebMailDomain();
												$_domain->Init(
													$_POST['textDomainName'],
													(isset($_POST['intIncomingMailProtocol']) && $_POST['intIncomingMailProtocol'] == 'IMAP4') ? WM_MAILPROTOCOL_IMAP4 : WM_MAILPROTOCOL_POP3,
													(isset($_POST['txtIncomingMail'])) ? $_POST['txtIncomingMail'] : null, 
													(isset($_POST['intIncomingMailPort'])) ? (int) $_POST['intIncomingMailPort'] : null, 
													(isset($_POST['txtOutgoingMail'])) ? $_POST['txtOutgoingMail'] : null, 
													(isset($_POST['intOutgoingMailPort'])) ? (int) $_POST['intOutgoingMailPort'] : null, 
													(isset($_POST['intReqSmtpAuthentication']) && $_POST['intReqSmtpAuthentication'] == 1) 
												);
												
												$_domain->SetSessionArray();
												
												if ($this->_db->DomainExist($_domain))
												{
													$_ref = '?mode=new&type='.urlencode($_POST['switchElement']);
													$_errorDesc = ap_Utils::TakePhrase('WM_DOMAIN_EXIST');
												}
												else
												{
													if ($this->_db->CreateDomain($_domain))
													{
														$_domain->ClearSessionArray();
														$_infoDesc = ap_Utils::TakePhrase('WM_DOMAIN_CREATESUCCESSFUL');
														$GLOBALS[AP_GLOBAL_USERFILTER_HREFS][] = AP_TYPE_WEBMAIL.AP_TYPE_DELIMITER.$_domain->_id;
													}
													else
													{
														$_ref = '?mode=new&type='.urlencode($_POST['switchElement']);
														$_errorDesc = ap_Utils::TakePhrase('WM_DOMAIN_CREATEUNSUCCESSFUL');
													}
												}
											}
											break;
											
										case 'int':
											if (isset($_POST['textDomainName']) && strlen($_POST['textDomainName']) > 0)
											{
												$_POST['textDomainName'] = strtolower($_POST['textDomainName']);
												
												include $this->PluginPath().'/common/class_domains.php';
												include $this->PluginPath().'/common/libs/class_xmail.php';
												
												$_WmSettings = new WMSettings($this->_settings->WmServerRootPath, $this->_settings->WmServerHost);
												$_domain = new CWebMailDomain();
												$_domain->Init(
													$_POST['textDomainName'],
													WM_MAILPROTOCOL_WMSERVER,
													$_WmSettings->Host, null,
													$_WmSettings->Host, $_WmSettings->OutPort,
													true 
												);
												
												$_domain->SetSessionArray();
												
												if ($this->_db->DomainExist($_domain))
												{
													$_ref = '?mode=new&type='.urlencode($_POST['switchElement']);
													$_errorDesc = ap_Utils::TakePhrase('WM_DOMAIN_EXIST');
												}
												else
												{
													if ($this->_db->CreateDomain($_domain))
													{
														$_domain->ClearSessionArray();
														$_infoDesc = ap_Utils::TakePhrase('WM_DOMAIN_CREATESUCCESSFUL');
														$GLOBALS[AP_GLOBAL_USERFILTER_HREFS][] = AP_TYPE_WEBMAIL.AP_TYPE_DELIMITER.$_domain->_id;
													}
													else
													{
														$_ref = '?mode=new&type='.urlencode($_POST['switchElement']);
														$_errorDesc = ap_Utils::TakePhrase('WM_DOMAIN_CREATEUNSUCCESSFUL');
													}
												}
											}	
											break;
									}
								}
								break;
							case 'edit':
								if (isset($_POST['uid']) && strlen($_POST['uid']) > 2 && strpos($_POST['uid'], 'wm') !== false) 
								{
									include $this->PluginPath().'/common/class_domains.php';
									
									$_domainId = -1;
									$_arr = explode(AP_UIDS_DELIMITER, $_POST['uid']);
									foreach ($_arr as $_uid)
									{
										$_arr = ap_Utils::UidExplode($_uid);
										if ($_arr[0] == AP_TYPE_WEBMAIL)
										{
											$_domainId = (int) $_arr[1];
										}
									}
									
									$_domain = new CWebMailDomain();
									$_domain->_id = $_domainId;
									$_domain->Init(
										null,
										null,
										(isset($_POST['txtIncomingMail'])) ? $_POST['txtIncomingMail'] : null, 
										(isset($_POST['intIncomingMailPort'])) ? (int) $_POST['intIncomingMailPort'] : null, 
										(isset($_POST['txtOutgoingMail'])) ? $_POST['txtOutgoingMail'] : null, 
										(isset($_POST['intOutgoingMailPort'])) ? (int) $_POST['intOutgoingMailPort'] : null, 
										(isset($_POST['intReqSmtpAuthentication']) && $_POST['intReqSmtpAuthentication'] == 1) 
									);
									
									$_domain->SetSessionArray();
									
									if ($_domainId > 0 && $this->_db->UpdateDomainById($_domain))
									{
										$_domain->ClearSessionArray();
										$_infoDesc = ap_Utils::TakePhrase('WM_DOMAIN_CREATESUCCESSFUL');
									}
									else
									{
										$_ref = '?mode=edit&uid='.urlencode($_POST['uid']);
										$_errorDesc = ap_Utils::TakePhrase('WM_DOMAIN_CREATEUNSUCCESSFUL').$this->_db->GetError();
									}
								}
								break;
						} /* switch ($_POST['mode_name']) */
					} /* if ($this->_ap->Tab() == 'domains') */
					else if ($this->_ap->Tab() == 'users')
					{
						$_domain = null;
						$_domainId = -1;
						$_key = (isset($_SESSION[AP_SESS_FILTER]) && strlen($_SESSION[AP_SESS_FILTER]) > 0) ? $_SESSION[AP_SESS_FILTER] : null;
						$_resp = $this->_thisIsMyUid($_key);
						
						if ($_resp == AP_TYPE_WEBMAIL.AP_TYPE_DELIMITER.'all') 
						{
							$_domainId = 0;
						}
						else
						{
							if ($_resp !== false)
							{
								$_arr = ap_Utils::UidExplode($_resp);
								if (strlen($_arr[0]) > 0)
								{
									$_domainId = (int) $_arr[1];
								}
							}
						}
						
						if ($_domainId === 0)
						{
							include_once $this->PluginPath().'/common/class_domains.php';
							$_domain = new CWebMailDomain();
							$_domain->Init(ap_Utils::TakePhrase('WM_FILTER_ALL'),
								WM_MAILPROTOCOL_ALL, 
								$this->_settings->IncomingMailServer,
								$this->_settings->IncomingMailPort, 
								$this->_settings->OutgoingMailServer, 
								$this->_settings->OutgoingMailPort,
								true);
							
							$_domain->_id = 0;
						}
						else if ($_domainId > 0)
						{
							include $this->PluginPath().'/common/class_domains.php';
							$_domain = $this->_db->SelectDomainById($_domainId);
						}
						
						switch ($_POST['mode_name'])
						{
							case 'collection':
								if ($_domain && isset($_POST['chCollection']) && count($_POST['chCollection']) > 0)
								{
									$_users_for_delete = array();
									foreach ($_POST['chCollection'] as $_value)
									{
										$_expl = explode(AP_UIDS_DELIMITER, $_value);
										if (is_array($_expl))
										{
											foreach ($_expl as $_item)
											{
												$_arr = ap_Utils::UidExplode($_item);
												if ($_arr[0] == AP_TYPE_WEBMAIL)
												{
													$_users_for_delete[] = (int) $_arr[1];
												}				
											}
										}
									}
									
									$_result = true;
									if (count($_users_for_delete) > 0)
									{
										foreach ($_users_for_delete as $_id)
										{
											if ($_result)
											{
												$_account =& $this->_db->SelectAccountData($_id);
												if ($_account)
												{
													$_mailProcessor = new MailProcessor($_account, $this->_db, $this->PluginPath().'/common/');
													$_result &= $_mailProcessor->DeleteAccount();
												}
												else
												{
													$_result = false;
												}
												unset($_account);
											}
										}										
									}
									
									if ($_result)
									{
										$_infoDesc = ap_Utils::TakePhrase('WM_DELETE_SUCCESSFUL');
									}
									else
									{
										$_errorDesc = ap_Utils::TakePhrase('WM_DELETE_UNSUCCESSFUL');
									}
								}
								
								break;
	
							case 'new':
								
								if (isset($_POST['switchElement']))
								{
									switch ($_POST['switchElement'])
									{
										case 'createUser':
											if ($_domain && $_domain->_mailProtocol != WM_MAILPROTOCOL_WMSERVER)
											{
												$_account = new Account($this->_settings, $_domain);
												$_account->DefaultAccount = true;
												
												$_sync = WM_FOLDERSYNC_AllHeadersOnly;
												$this->_updateAccountFromPost($_account, $_sync);
												
												$_account->SetSessionArray();
								
												$_mailProcessor = new MailProcessor($_account, $this->_db, $this->PluginPath().'/common/');
												if ($_mailProcessor->MailStorage->Connect(true))
												{
													if ($_mailProcessor->CreateAccount($_account, $_sync))
													{
														$_account->ClearSessionArray();
														$_infoDesc = ap_Utils::TakePhrase('WM_ACCOUNT_CREATESUCCESSFUL');
													}
													else
													{
														$_ref = '?mode=new&type=new';
														$_errorDesc = $_mailProcessor->GetError();
													}
												}
												else
												{
													$_ref = '?mode=new&type=new';
													$_errorDesc = $_mailProcessor->MailStorage->GetError();
												}
											}
				
											break;

										case 'new':
											if ($_domain && $_domain->_mailProtocol == WM_MAILPROTOCOL_WMSERVER && isset($_POST['userType']) && isset($_POST['txtXmailLogin']) && isset($_POST['txtXmailPassword']) && $_POST['userType'] == 'new')
											{
												if ($this->_settings->EnableWmServer && !file_exists($this->_settings->WmServerRootPath.'/server.tab'))
												{
													$_ref = '?mode=new&type=new';
													$_errorDesc = ap_Utils::TakePhrase('WM_INFO_ROOTPATHINCORRECT');
												} 
												else if (strlen(trim($_POST['txtXmailLogin'])) == 0 || strlen(trim($_POST['txtXmailPassword'])) == 0)
												{
													$_errorDesc = ap_Utils::TakePhrase('WM_ERROR_USERNAMEPASSWORDNULL');
												}
												else
												{
													$_account = new Account($this->_settings, $_domain);
													$_account->DefaultAccount = true;
													
													$_account->MailProtocol = WM_MAILPROTOCOL_WMSERVER;
													$_account->Email = $_POST['txtXmailLogin'].'@'.$_domain->_name;
													$_account->MailIncLogin = $_POST['txtXmailLogin'];
													$_account->MailIncPassword = $_POST['txtXmailPassword'];
													$_account->Delimiter = '.';
													
													$_sync = WM_FOLDERSYNC_AllHeadersOnly;
													$_mailProcessor = new MailProcessor($_account, $this->_db, $this->PluginPath().'/common/');

													if ($_mailProcessor->CreateAccount($_account, $_sync))
													{
														$_infoDesc = ap_Utils::TakePhrase('WM_ACCOUNT_CREATESUCCESSFUL');
													}
													else
													{
														$_ref = '?mode=new&type=new';
														$_errorDesc = $_mailProcessor->GetError();
													}
												}
											}
											break;
										case 'mlist':
											if ($_domain && $_domain->_mailProtocol == WM_MAILPROTOCOL_WMSERVER && isset($_POST['userType']) && isset($_POST['txtXmailLogin']) && $_POST['userType'] == 'mlist')
											{
												if (strlen(trim($_POST['txtXmailLogin'])) == 0)
												{
													$_errorDesc = ap_Utils::TakePhrase('WM_ERROR_USERNAMENULL');
												}
												else
												{
													$_account = new Account($this->_settings, $_domain);
													$_account->DefaultAccount = true;
													$_account->IsMailList = true;
													
													$_account->MailProtocol = WM_MAILPROTOCOL_WMSERVER;
													$_account->Email = $_POST['txtXmailLogin'].'@'.$_domain->_name;
													$_account->MailIncLogin = $_POST['txtXmailLogin'];
													$_account->MailIncPassword = $_POST['txtXmailPassword'];
													$_account->Delimiter = '.';
													
													$_sync = WM_FOLDERSYNC_AllHeadersOnly;
													$_mailProcessor = new MailProcessor($_account, $this->_db, $this->PluginPath().'/common/');

													if ($_mailProcessor->CreateAccount($_account, $_sync))
													{
														$_infoDesc = ap_Utils::TakePhrase('WM_ACCOUNT_CREATESUCCESSFUL');
													}
													else
													{
														$_ref = '?mode=new&type=mlist';
														$_errorDesc = $_mailProcessor->GetError();
													}
												}
											}
											break;
									}
								}
								break;
							case 'edit':
								if (isset($_POST['switchElement']))
								{
									switch ($_POST['switchElement'])
									{
										case 'edit':
											
											if ($_domain && isset($_POST['uid']) && strlen($_POST['uid']) > 2 &&
													isset($_POST['intAccountId']) && (int) $_POST['intAccountId'] > 0)
											{
												$_postArray = new Account($this->_settings, $_domain);
												
												$_sync = WM_FOLDERSYNC_AllHeadersOnly;
												$this->_updateAccountFromPost($_postArray, $_sync);
												
												$_postArray->SetSessionArray();
											
												$_account =& $this->_db->SelectAccountData($_POST['intAccountId']);
												if ($_account && !$_account->IsMailList)
												{
													$this->_updateAccountFromPost($_account, $_sync);
													
													$_mailProcessor = new MailProcessor($_account, $this->_db, $this->PluginPath().'/common/');
													if (true)
													{
														if ($_mailProcessor->UpdateAccount($_account, $_sync))
														{
															$_account->ClearSessionArray();
															$_infoDesc = ap_Utils::TakePhrase('WM_ACCOUNT_CREATESUCCESSFUL');
														}
														else
														{
															$_ref = '?mode=edit&uid='.urlencode($_POST['uid']);
															$_errorDesc = $_mailProcessor->GetError();
															if (strlen($_errorDesc) == 0)
															{
																$_errorDesc = ap_Utils::TakePhrase('WM_ACCOUNT_CREATEUNSUCCESSFUL');
															}
														}
													}
													else
													{
														$_ref = '?mode=edit&uid='.urlencode($_POST['uid']);
														$_errorDesc = $_mailProcessor->MailStorage->GetError();
														if (strlen($_errorDesc) == 0)
														{
															$_errorDesc = ap_Utils::TakePhrase('WM_ACCOUNT_CREATEUNSUCCESSFUL');
														}
													}
												}				
											}
											break;
									}
								}
								break;
								
						} /* switch ($_POST['mode_name']) */
					} /* else if ($this->_ap->Tab() == 'users') */
							
					$this->Disconnect();
				}
				else
				{
					$_errorDesc = ap_Utils::TakePhrase('WM_INFO_CONNECTUNSUCCESSFUL');
				}
			}
			else
			{
				$_saveSettings = false;
			}

			if ($_saveSettings)
			{
				if ($this->_settings->SaveToXml())
				{
					$_infoDesc = strlen($_infoDesc) > 0 ? $_infoDesc : ap_Utils::TakePhrase('WM_INFO_SAVESUCCESSFUL');
				}
				else
				{
					$_errorDesc = strlen($_errorDesc) > 0 ? $_errorDesc : ap_Utils::TakePhrase('WM_INFO_SAVESUCCESSFUL');
				}
			}
			if (strlen($_errorDesc) > 0)
			{
				$this->_setError($_errorDesc);
			}
			else if(strlen($_infoDesc) > 0)
			{
				$this->_setInfo($_infoDesc);
			}
					
			return $_ref;
		}
		
		function WritePop()
		{
			if (!$this->_isLoad)
			{
				CAdminPanel::GlobalError(ap_Utils::TakePhrase('WM_INFO_CANTLOAD_SETTINGS'));
			}
			
			$_type = isset($_GET['type']) ? $_GET['type'] : 'null';
			switch ($_type)
			{
				default:
					break;
				case 'log':
				case 'log_all':
					$_text = '';
					$_minisize = 50000;
					$_fileName =  $this->_settings->_path.'/logs/log_'.date('Y-m-d').'.txt';

					if (file_exists($_fileName))
					{
						$_size = @filesize($_fileName);
						if ($_size && $_size > 0)
						{
							$_fh = @fopen($_fileName, 'rb');
							if ($_fh)
							{
								if ($_type == 'log' && $_size > $_minisize)
								{
									@fseek($_fh, $_size - $_minisize);
									$_text = @fread($_fh, $_minisize);
								}
								else 
								{
									$_text = @fread($_fh, $_size);
								}
							}
							else 
							{
								$_text = 'log file can\'t be read';
							}
						}
					}
					
					$_text = strlen($_text) > 0 ? $_text : 'log file is empty';
					$_text = str_replace('<?xml', '<?_xml', $_text);
					
					header('Content-Type: text/plain; charset=utf-8');
					header('Content-Length: '.strlen($_text));
					echo $_text;
					break;
				case 'info':
					if ($this->_ap->IsEnable())
					{
						echo '<center><b>ver. '.AP_VERSION.'</b><br />'.WM_INI_DIR.
						'<br />'.WM_WEB_DIR.'<br />'.__FILE__.'<br />'.'<br /><br /></center>';
						phpinfo();
					}
					break;
					
				case 'db':
					if (isset($_GET['action']))
					{
						$_pp = $this->PluginPath();
						include $_pp.'/common/db/class_dbsql.php';
						include $_pp.'/common/db/dbstorage.php';
						
						switch ($_GET['action'])
						{
							case 'create':
								include $_pp.'/common/db/create.php';
								break;
							case 'update':
								include $_pp.'/common/db/update.php';
								break;
						}
					}
					
					break;
			}
		}
		
		function InitScreen(&$_screen, $_action) 
		{
			if (!$this->_isLoad)
			{
				$this->_setError(ap_Utils::TakePhrase('WM_INFO_CANTLOAD_SETTINGS'));	
			}
			
			switch ($_action)
			{
				case 'initRootPath':
					$_screen->_rootPath =& $this->_pluginInfo->Path;
					return true;
				case 'initMenu':
					$this->_initMenu($_screen);
					return true;
				case 'initStandardData':
					$this->_initWebMailData($_screen);
					return true;
				case 'initSearch':
					$this->_initSearch($_screen);
					return true;
				case 'initFilter':
					$this->_initFilter($_screen);
					return true;
				case 'initTable':
					$this->_initTable($_screen);
					return true;
				case 'initMain':
					$this->_initMain($_screen);
					return true;
			}

			return false;
		}
		
		function IncludeCommon()
		{
			$_pp = $this->PluginPath();
			include $_pp.'/common/constans.php';
			include $_pp.'/common/settings.php';
			
			include $_pp.'/common/class_datetime.php';
			include $_pp.'/common/class_account.php';
			
			include $_pp.'/common/class_collectionbase.php';
			include $_pp.'/common/class_folders.php';
			
			include $_pp.'/common/class_mailprocessor.php';
			
			if (!$this->_loadSettings())
			{
				$this->_isLoad = false;
			}
		}
		
		/**
		 * @return	bool
		 */
		function Connect()
		{
			if ($this->_isConnect)
			{
				CAdminPanel::Log('DB : Repeating a connection (return true)');
				return true;
			}
			
			if (!defined('INCLUDEDBCLASS'))
			{
				include $this->PluginPath().'/common/db/class_dbsql.php';
				include $this->PluginPath().'/common/db/dbstorage.php';
				define('INCLUDEDBCLASS', 1);
			}
			
			$this->_db =& DbStorageCreator::CreateDatabaseStorage($this->_settings);
			CAdminPanel::Log('DB : Start Connect');
			if ($this->_db->Connect())
			{
				$this->_isConnect = true;
			}
			else
			{
				CAdminPanel::Log('DB : Connect Error ('.$this->_db->_connector->ErrorDesc.')');	
			}
			
			return $this->_isConnect;
		}
		
		function Disconnect()
		{
			if ($this->_isConnect && $this->_db)
			{
				$this->_db->Disconnect();
				$this->_isConnect = false;
			}
		}
		
		/**
		 * @return bool
		 */
		function IsXMailExist()
		{
			return in_array(AP_TYPE_XMAIL, $this->_pluginIndexs);
		}
		
		function _initSearch(&$_screen)
		{
			if (strlen($this->_searchDesc) > 0)
			{
				$_screen->SetSearchDesc($this->_searchDesc);
			}
		}
		
		function _initMenu(&$_screen)
		{
			switch ($this->_ap->Tab())
			{
				case 'wm':
					$_screen->AddMenuItem(WM_MODE_DB, WM_TABNAME_DB, 'db.php');
					$_screen->AddMenuItem(WM_MODE_WEBMAIL, WM_TABNAME_WEBMAIL, 'webmail.php');
					$_screen->AddMenuItem(WM_MODE_INTERFACE, WM_TABNAME_INTERFACE, 'interface.php');
					$_screen->AddMenuItem(WM_MODE_LOGIN, WM_TABNAME_LOGIN, 'login.php');
					$_screen->AddMenuItem(WM_MODE_CAL, WM_TABNAME_CAL, 'cal.php', array('cal.js'));
					$_screen->AddMenuItem(WM_MODE_DEBUG, WM_TABNAME_DEBUG, 'debug.php');
					if ($this->_isLoad && $this->_settings->EnableWmServer)
					{
						$_screen->AddMenuItem(WM_MODE_INTEGRATION, WM_TABNAME_INTEGRATION, 'integr.php');
					}
					$_screen->SetDefaultMode(WM_MODE_WEBMAIL);
					break;
				case 'users':
					$_screen->AddTopMenuButton('New User', 'new_contact.gif', 'DoNew("new", "'.AP_INDEX_FILE.'");');
					$_screen->AddTopMenuButton('Delete', 'delete.gif', 'DoDeleteUsers();', null, true);
					break;
				case 'domains':
					$_name = ($this->IsXMailExist()) ? 'New External Domain' : 'New Domain';
					$_screen->AddTopMenuButton($_name, 'new-domain.png', 'DoNew("ext", "'.AP_INDEX_FILE.'");');
					$_screen->AddTopMenuButton('Delete', 'delete.gif', 'DoDeleteDomains();', null, true);
					break;
			}
		}
		
		function _initFilter(&$_screen)
		{
			if ($this->_ap->Tab() == 'users')
			{
				if ($this->Connect())
				{
					$_screen->InitFilter();
						
					$_filterItem = new ap_Screen_Filter_Item();
					$_filterItem->href = AP_TYPE_WEBMAIL.AP_TYPE_DELIMITER.'all';
					$_filterItem->name = WM_FILTER_ALL;
					$_filterItem->type = AP_TYPE_WEBMAIL;
					$_filterItem->class = 'domWebMail';
					$_screen->_filter->AddItem($_filterItem, true);
					
					$_dlist = $this->_db->DomainList();
					if (is_array($_dlist))
					{
						foreach ($_dlist as $_id => $_domain)
						{
							if (count($_domain) == 2)
							{
								if ($_domain[1] == WM_MAILPROTOCOL_WMSERVER)
								{
									if ($this->IsXMailExist())
									{
										$_filterItem = new ap_Screen_Filter_Item();
										$_filterItem->href = AP_TYPE_WEBMAIL.AP_TYPE_DELIMITER.$_id;
										$_filterItem->name = $_domain[0];
										$_filterItem->type = AP_TYPE_XMAIL;
										$_filterItem->class = 'domWebMail';
										
										$_screen->_filter->AddItem($_filterItem);
										unset($_filterItem);
									}
								}
								else
								{
									$_filterItem = new ap_Screen_Filter_Item();
									$_filterItem->href = AP_TYPE_WEBMAIL.AP_TYPE_DELIMITER.$_id;
									$_filterItem->name = $_domain[0];
									$_filterItem->type = AP_TYPE_WEBMAIL;
									$_filterItem->class = 'domWebMail';
									
									$_screen->_filter->AddItem($_filterItem);
									unset($_filterItem);
								}
							}
						}
					}
				}
				else
				{
					$_screen->InitFilter();
						
					$_filterItem = new ap_Screen_Filter_Item();
					$_filterItem->href = AP_TYPE_WEBMAIL.AP_TYPE_DELIMITER.'all';
					$_filterItem->name = WM_FILTER_ALL;
					$_filterItem->type = AP_TYPE_WEBMAIL;
					$_filterItem->class = 'domWebMail';
					$_screen->_filter->AddItem($_filterItem, true);
					
					$this->_setError(ap_Utils::TakePhrase('WM_INFO_CONNECTUNSUCCESSFUL'));
				}
			}
		}
		
		function _initTable(&$_screen)
		{
			if ($this->Connect())
			{
				if ($this->_ap->Tab() == 'domains')
				{
					$_screen->SetNullPhrase(ap_Utils::TakePhrase('LANG_NODOMAINS'));
					$_screen->InitTable();
					
					$_screen->ClearHeaders();
					$_screen->AddHeader('Type', 42);
					$_screen->AddHeader('Name', 138, true);
					
					$this->_initDomainsData($_screen);
				}
				else if ($this->_ap->Tab() == 'users')
				{
					$_screen->SetNullPhrase(ap_Utils::TakePhrase('LANG_NOUSERSINDOMAIN'));
					$_screen->InitTable();
					
					$_screen->ClearHeaders();
					$_screen->AddHeader('Type', 42);
					$_screen->AddHeader('Email', 138, true);
					
					$this->_initUsersData($_screen);
					
					if ($this->_settings->EnableWmServer && !file_exists($this->_settings->WmServerRootPath.'/server.tab'))
					{
						$this->_setError(ap_Utils::TakePhrase('WM_INFO_ROOTPATHINCORRECT'));		
					}
				}
			}
			else
			{
				if ($this->_ap->Tab() == 'domains')
				{
					$_screen->SetNullPhrase(ap_Utils::TakePhrase('LANG_NODOMAINS'));
					$_screen->InitTable();
					
					$_screen->ClearHeaders();
					$_screen->AddHeader('Type', 42);
					$_screen->AddHeader('Name', 138, true);
				}
				else if ($this->_ap->Tab() == 'users')
				{
					$_screen->SetNullPhrase(ap_Utils::TakePhrase('LANG_NOUSERSINDOMAIN'));
					$_screen->InitTable();
					
					$_screen->ClearHeaders();
					$_screen->AddHeader('Type', 42);
					$_screen->AddHeader('Name', 138, true);
				}
				
				$this->_setError(ap_Utils::TakePhrase('WM_INFO_CONNECTUNSUCCESSFUL'));
			}
		}
		
		function _initDomainsData(&$_screen)
		{
			$_list = $this->_db->DomainList($this->_searchDesc);
			if (is_array($_list))
			{
				foreach ($_list as $_id => $_domainArray)
				{
					if (count($_domainArray) == 2)
					{
						if ($_domainArray[1] == WM_MAILPROTOCOL_WMSERVER)
						{
							if ($this->IsXMailExist())
							{
								$_tableItem = new ap_Screen_Table_Item();
								$_tableItem->href = AP_TYPE_WEBMAIL.AP_TYPE_DELIMITER.$_id;
								$_tableItem->name = $_domainArray[0];
								$_tableItem->type = AP_TYPE_XMAIL;
								
								$_tableItem->values = array(
									'Type' => '<img src="'.$this->_ap->AdminFolder().'/images/xmail-domain-icon-big.png">',
									'Name' => $_domainArray[0]
								);
								
								$_screen->_table->AddItem($_tableItem);
								unset($_tableItem);
							}
						}
						else
						{
							$_tableItem = new ap_Screen_Table_Item();
							$_tableItem->href = AP_TYPE_WEBMAIL.AP_TYPE_DELIMITER.$_id;
							$_tableItem->name = $_domainArray[0];
							$_tableItem->type = AP_TYPE_WEBMAIL;
							$_tableItem->values = array(
								'Type' => '<img src="'.$this->_ap->AdminFolder().'/images/wm-domain-icon-big.png">',
								'Name' => $_domainArray[0]
							);
							
							$_screen->_table->AddItem($_tableItem);
							unset($_tableItem);
						}
					}
				}
			}
		}
		
		function _initUsersData(&$_screen)
		{
			include_once $this->PluginPath().'/common/class_domains.php';
							
			$_domainId = -1;
			
			$_uids = explode(AP_UIDS_DELIMITER, $_screen->GetSelectedItemKey());
			foreach ($_uids as $_value)
			{
				$_arr = ap_Utils::UidExplode($_value);
				if ($_arr[0] == AP_TYPE_WEBMAIL)
				{
					$_domainId = ($_arr[1] === 'all') ? 0 : (int) $_arr[1];
					break;
				}
			}
			
			$_domain = null;
			if ($_domainId == 0)
			{
				$_domain = new CWebMailDomain();
				$_domain->Init('', WM_MAILPROTOCOL_ALL, '', 0, '', 0, true);
				$_domain->_id = 0;
			}
			else if ($_domainId > 0)
			{
				$_domain = $this->_db->SelectDomainById($_domainId);
			}
			
			if ($_domain)
			{
				if ($_domain->_mailProtocol == WM_MAILPROTOCOL_WMSERVER)
				{
					$_screen->AddTopMenuButton('New Mailing List', 'new_contact.gif', 'DoNew("mlist", "'.AP_INDEX_FILE.'");');
				}
				
				$_screen->ClearHeaders();
				$_screen->AddHeader('Type', 42);
				$_screen->AddHeader('Email', 150, true);
				$_screen->AddHeader('Last Login', 95);
				$_screen->AddHeader('Mailbox Size', 100);
				
				if (strlen($this->_searchDesc) > 0)
				{
					$_UsersCount = $this->_db->AccountCount($_domain->_id, $this->_searchDesc);
				}
				else
				{
					$_UsersCount = $this->_db->AccountCount($_domain->_id);
				}
				
				if (!$this->IsXMailExist())
				{
					$_AllUsersCount = $this->_db->AllUserCount($_domain->_id);
					$_screen->SetLowToolBarText(ap_Utils::TakePhrase('LANG_TOTAL_USERS').': '.$_AllUsersCount);
				}
				
				if ($_UsersCount > 0)
				{
					$_screen->_table->UseCurrentList();
					$_screen->_table->SetListCount($_UsersCount);
					$_page = $_screen->_table->GetPage($_UsersCount);

					$_list = $this->_db->AccountList($_domain->_id, $_page, $_screen->_table->GetLinePerPage(),
						$this->_tableFieldToDbColumn($_screen->_table->_orderColumn),
						(bool) $_screen->_table->_orderType,
						$this->_searchDesc);
					
					if (is_array($_list))
					{
						foreach ($_list as $_id => $_acctArray)
						{
							if (count($_acctArray) == 8)
							{
								$_mailboxSize = ap_Utils::GetFriendlySize($_acctArray[4]);
								
								/* $_screen->SetLowToolBarText('Account count: '.$_UsersCount); */
								
								$_datetime = new CDateTime();
								$_datetime->SetFromANSI($_acctArray[2]);
								$_lastLogin = date('Y-m-d H:i', $_datetime->TimeStamp);
							
								$_tableItem = new ap_Screen_Table_Item();
								$_emailArray = ap_Utils::ParseEmail($_acctArray[1]);
								
								$_acctDomain = (count($_emailArray) == 2) ? $_emailArray[0] : $_acctArray[1];
								
								$_xmailHref = ($_domain->_id == 0) ? AP_TYPE_WEBMAIL.AP_TYPE_DELIMITER.$_id : AP_TYPE_XMAIL.AP_TYPE_DELIMITER.$_acctDomain.AP_UIDS_DELIMITER.AP_TYPE_WEBMAIL.AP_TYPE_DELIMITER.$_id;
								$_tableItem->href = ($_acctArray[7] == WM_MAILPROTOCOL_WMSERVER)
									? $_xmailHref
									: AP_TYPE_WEBMAIL.AP_TYPE_DELIMITER.$_id;
								
								$_tableItem->name = $_acctArray[1];
								$_tableItem->type = AP_TYPE_WEBMAIL;
								
								$_img = ($_acctArray[6]) ? 'M.gif' : 'U.gif';
								$_tableItem->values = array(
									'Type' => '<img src="'.$this->_ap->AdminFolder().'/images/icons/'.$_img.'">',
									'Email' => $_acctArray[1], 
									'Last Login' => $_lastLogin,
									'Mailbox Size' => $_mailboxSize
								);
									
								$_screen->_table->AddItem($_tableItem);
								unset($_tableItem);
							}
						}
					}
					else if ($_list === false)
					{
						$this->_setError(ap_Utils::TakePhrase('WM_CANTGET_ACCOUNTS_LIST'));
					}
				}
			}
		}
		
		/**
		 * @param	string	$field
		 * @return	string|null
		 */
		function _tableFieldToDbColumn($_field)
		{
			switch ($_field)
			{
				case 'Email': return 'email';
				case 'Last Login': return 'nlast_login';
				case 'Logins': return 'logins_count';
				case 'Mailbox Size': return 'mailbox_size';
			}
			return null;
		}
		
		function _initMain(&$_screen)
		{
			if ($this->_ap->Tab() == 'domains')
			{
				switch ($this->_ap->Mode())
				{
					case 'new':
		
						$_switcher = null;
						$_type = (isset($_GET['type'])) ? $_GET['type'] : '';

						if ($_type == 'ext')
						{
							$_screen->_main->AddSwitcher('ext', 'This is external domain', $this->PluginPath().'/templates/new-domain.php');
							$_switcher =& $_screen->_main->GetSwitcher('ext');
						}
						
						if ($_switcher !== null)
						{
							include_once $this->PluginPath().'/common/class_domains.php';
							
							$_domain = new CWebMailDomain();
							$_domain->UpdateFromSessionArray();
					
							$this->_updateScreenDataFromDomain($_switcher->data, $_domain);
						}
						break;
						
					case 'edit':
						if (isset($_GET['uid']) && strlen($_GET['uid']) > 3 && strpos($_GET['uid'], AP_TYPE_WEBMAIL) !== false)
						{
							if ($this->Connect())
							{
								include_once $this->PluginPath().'/common/class_domains.php';
								
								$_domainId = -1;
								
								$_uids = explode(AP_UIDS_DELIMITER, $_GET['uid']);
								foreach ($_uids as $_value)
								{
									$_arr = ap_Utils::UidExplode($_value);
									if ($_arr[0] == AP_TYPE_WEBMAIL)
									{
										$_domainId = (int) $_arr[1];
										break;
									}
								}
								
								$_domain = $this->_db->SelectDomainById($_domainId);
								if ($_domain)
								{
									if ($_domain->_mailProtocol == WM_MAILPROTOCOL_WMSERVER)
									{
										$_screen->_main->AddSwitcher('edit', 'This is edit domain', $this->PluginPath().'/templates/edit-xm-domain.php');
									}
									else
									{
										$_screen->_main->AddSwitcher('edit', 'This is edit domain', $this->PluginPath().'/templates/edit-domain.php');
									}
									
									$_switcher =& $_screen->_main->GetSwitcher('edit');
									if ($_switcher !== null)
									{
										$_switcher->data->SetValue('uid', urlencode($_GET['uid']));
										
										$_domain->UpdateFromSessionArray();
								
										$this->_updateScreenDataFromDomain($_switcher->data, $_domain);
									}
								}
							}
							else
							{
								$this->_setError(ap_Utils::TakePhrase('WM_INFO_CONNECTUNSUCCESSFUL'));
							}
						}
						break;
				}
			}
			else if ($this->_ap->Tab() == 'users')
			{
				$_filterDomain = -1;
				$_resp = $this->_thisIsMyUid($_screen->GetSelectedItemKey());
				if ($_resp !== false)
				{
					$_filterDomain = (int) substr($_resp, 3);
				}
				
				$_domain = null;
				if (!$this->Connect())
				{
					$this->_setError(ap_Utils::TakePhrase('WM_INFO_CONNECTUNSUCCESSFUL'));
					return false;
				}
				else if ($_filterDomain == 0)
				{
					include_once $this->PluginPath().'/common/class_domains.php';
					
					$_domain = new CWebMailDomain();
					$_domain->Init(ap_Utils::TakePhrase('WM_FILTER_ALL'),
						WM_MAILPROTOCOL_ALL, 
						$this->_settings->IncomingMailServer,
						$this->_settings->IncomingMailPort, 
						$this->_settings->OutgoingMailServer, 
						$this->_settings->OutgoingMailPort,
						true);
					
					$_domain->_id = 0;
				} 
				else if ($_filterDomain > 0)
				{
					include_once $this->PluginPath().'/common/class_domains.php';
					$_domain = $this->_db->SelectDomainById($_filterDomain);
				}

				switch ($this->_ap->Mode())
				{
					case 'new':

						$_switcher = null;
						$_type = (isset($_GET['type'])) ? $_GET['type'] : '';
						
						if ($_domain && $_type == 'new')
						{
							switch ($_domain->_mailProtocol)
							{
								case WM_MAILPROTOCOL_POP3:
									$_screen->_main->AddSwitcher('createUser', 'Add remote mail account', $this->PluginPath().'/templates/edit-user-pop3.php');
									break;
								case WM_MAILPROTOCOL_IMAP4:
									$_screen->_main->AddSwitcher('createUser', 'Add remote mail account', $this->PluginPath().'/templates/edit-user-imap4.php');
									break;
								case WM_MAILPROTOCOL_ALL:
									$_screen->_main->AddSwitcher('createUser', 'Add remote mail account', $this->PluginPath().'/templates/new-user-pop3-imap4.php');
									break;
							}
							
							$_account = new Account($this->_settings, $_domain);
							$_account->MailProtocol = ($_account->MailProtocol == WM_MAILPROTOCOL_ALL) ? $this->_settings->IncomingMailProtocol : $_account->MailProtocol;
								
							$_switcher =& $_screen->_main->GetSwitcher('createUser');
							if ($_switcher !== null)
							{
								$_switcher->data->SetValue('DomainName', $_domain->_name);
								$_switcher->data->SetValue('intDomainId', $_domain->_id);
								
								$_folderSyncType = WM_FOLDERSYNC_AllHeadersOnly;
								if ($_account->MailProtocol == WM_MAILPROTOCOL_POP3)
								{
									$_folderSyncType = WM_FOLDERSYNC_AllEntireMessages;	
								}
								$_switcher->data->SetValue('folderSyncType', $_folderSyncType);

								$_account->UpdateFromSessionArray();
								
								$this->_updateScreenDataFromAccount($_switcher->data, $_account, true);
							}
						}
						break;
						
					case 'edit':
						if ($_domain && isset($_GET['uid']))
						{
							$_account = null;
							$_acctId = -1;
							
							$_resp = $this->_thisIsMyUid($_GET['uid']);
							if ($_resp !== false)
							{
								$_arr = ap_Utils::UidExplode($_resp);
								if (strlen($_arr[0]) > 0)
								{
									$_acctId = (int) $_arr[1];
								}
							}
							
							if ($_acctId > 0)
							{
								$_account =& $this->_db->SelectAccountData($_acctId);
							}
							
							if ($_account && !$_account->IsMailList)
							{
								switch ($_account->MailProtocol)
								{
									case WM_MAILPROTOCOL_POP3:
										if (($_domain->_id == 0))
										{
											$_screen->_main->AddSwitcher('edit', 'Edit remote mail account', $this->PluginPath().'/templates/edit-user-pop3-nodomain.php');
										}
										else
										{
											$_screen->_main->AddSwitcher('edit', 'Edit remote mail account', $this->PluginPath().'/templates/edit-user-pop3.php');
										}
										break;
									case WM_MAILPROTOCOL_IMAP4:
										if (($_domain->_id == 0))
										{
											$_screen->_main->AddSwitcher('edit', 'Edit remote mail account', $this->PluginPath().'/templates/edit-user-imap4-nodomain.php');
										}
										else
										{
											$_screen->_main->AddSwitcher('edit', 'Edit remote mail account', $this->PluginPath().'/templates/edit-user-imap4.php');
										}
										break;
									case WM_MAILPROTOCOL_WMSERVER:
										if (($_domain->_id == 0))
										{
											$_screen->_main->AddSwitcher('edit', 'Edit remote mail account', $this->PluginPath().'/templates/edit-user-wm-nodomain.php');
										}
										break;
								}
									
								$_switcher =& $_screen->_main->GetSwitcher('edit');

								if ($_switcher !== null)
								{
									if ($_domain->_mailProtocol !== WM_MAILPROTOCOL_WMSERVER)
									{
										$_switcher->data->SetValue('DomainName', $_domain->_name);
										$_switcher->data->SetValue('intDomainId', $_domain->_id);
										
										$_folderSyncType = $this->_db->GetFolderSyncTypeByFolderType($_account->Id, WM_FOLDERTYPE_Inbox);
										if ($_folderSyncType > -1)
										{
											$_switcher->data->SetValue('folderSyncType', $_folderSyncType);
										}
									}
									
									$_switcher->data->SetValue('intAccountId', $_account->Id);
									$_switcher->data->SetValue('uid', $_GET['uid']);
									
									$_account->UpdateFromSessionArray();
									
									$this->_updateScreenDataFromAccount($_switcher->data, $_account);	
								}
							}
						}
						break;
				}
			}
			
			return true;
		}
		
		/**
		 * @param string $_uid
		 * @return false|string
		 */
		function _thisIsMyUid($_uid)
		{
			$_uids = explode(AP_UIDS_DELIMITER, $_uid);
			foreach ($_uids as $_item)
			{
				if (substr($_item, 0, 2) == AP_TYPE_WEBMAIL)
				{
					return $_item;
				}
			}
			
			return false;
		}
		
		/**
		 * @return	bool
		 */
		function _loadSettings()
		{
			$_webPath = $this->_ap->GetCfg('webmail_web_path');
			if ($_webPath === false)
			{
				return false;
			}
			else if (!defined('WM_WEB_DIR')) 
			{
				define('WM_WEB_DIR', $_webPath);
			}
			unset($_webPath);
						
			if (file_exists(WM_WEB_DIR.'/inc_settings_path.php'))
			{
				$dataPath = null;
				include WM_WEB_DIR.'/inc_settings_path.php';
				if ($dataPath !== null)
				{
					$dataPath = ap_Utils::GetFullPath($dataPath, WM_WEB_DIR);
					if (!defined('WM_INI_DIR')) 
					{
						define('WM_INI_DIR', $dataPath); 
					}
				}
				else
				{
					return false;
				}
				
				unset($dataPath);
			}
			else
			{
				return false;
			}
			
			$this->_settings = new WebMail_Settings(WM_INI_DIR, WM_WEB_DIR);
			
			return ($this->_settings && $this->_settings->isLoad);
		}
		
		function _initWebMailData(&$_screen)
		{
			if ($this->_isLoad)
			{
				$_screen->AddGlobalJs('webmail.js');
				
				/* db */
				if ($this->_useDbCreate || $this->_ap->IsEnable())
				{
					$_screen->data->SetValue('txtCreateDb', '
					<input type="submit" name="create_db" id="create_db" value="+" class="wm_button" title="Create Database" />
					<input type="submit" name="drop_db" id="drop_db" value="&mdash;" class="wm_button" title="Drop Database" />');
				}
				
				$_screen->data->SetValue('intDbTypeValue0', WM_DB_MSSQLSERVER);
				$_screen->data->SetValue('intDbTypeValue1', WM_DB_MYSQL);
				
				if (!extension_loaded('mssql'))
				{
					$_screen->data->SetValue('colDbTypeValue0', ' color="#aaa"');
				}
				if (!extension_loaded('mysql'))
				{
					$_screen->data->SetValue('colDbTypeValue1', ' color="#aaa"');
				}
				if (!extension_loaded('odbc'))
				{
					$_screen->data->SetValue('colDbTypeValue2', ' color="#aaa"');
				} 
				
				switch ($this->_settings->DbType)
				{
					case WM_DB_MSSQLSERVER:
						$_screen->data->SetValue('intDbType0', true);
						break;
					default:
					case WM_DB_MYSQL:
						$_screen->data->SetValue('intDbType1', true);
						break;
				}
				
				$_screen->data->SetValue('txtSqlLogin', $this->_settings->DbLogin);
				if (strlen($this->_settings->DbPassword) > 0)
				{
					$_screen->data->SetValue('txtSqlPassword', AP_DUMMYPASSWORD);
				}
				$_screen->data->SetValue('txtSqlName', $this->_settings->DbName);
				$_screen->data->SetValue('txtSqlDsn', $this->_settings->DbDsn);
				$_screen->data->SetValue('txtSqlSrc', $this->_settings->DbHost);
				
				$_screen->data->SetValue('odbcConnectionString', $this->_settings->DbCustomConnectionString);
				$_screen->data->SetValue('useCS', $this->_settings->UseCustomConnectionString);
				
				/* webmail */
				$_screen->data->SetValue('txtSiteName', $this->_settings->WindowTitle);
				$_screen->data->SetValue('txtIncomingMail', $this->_settings->IncomingMailServer);
				$_screen->data->SetValue('intIncomingMailPort', $this->_settings->IncomingMailPort);
				
				$_screen->data->SetValue('intIncomingMailProtocolPop3Value', WM_MAILPROTOCOL_POP3);
				$_screen->data->SetValue('intIncomingMailProtocolImap4Value', WM_MAILPROTOCOL_IMAP4);
				switch ($this->_settings->IncomingMailProtocol)
				{
					default:
					case WM_MAILPROTOCOL_POP3:
						$_screen->data->SetValue('intIncomingMailProtocol0', $this->_settings->IncomingMailPort);
						break;
					case WM_MAILPROTOCOL_IMAP4:
						$_screen->data->SetValue('intIncomingMailProtocol1', $this->_settings->IncomingMailPort);
						break;
				}
				
				$_screen->data->SetValue('txtOutgoingMail', $this->_settings->OutgoingMailServer);
				$_screen->data->SetValue('intOutgoingMailPort', $this->_settings->OutgoingMailPort);
				
				$_screen->data->SetValue('intReqSmtpAuthentication', $this->_settings->ReqSmtpAuth);
				$_screen->data->SetValue('intAllowDirectMode', $this->_settings->AllowDirectMode);
				$_screen->data->SetValue('intDirectModeIsDefault', $this->_settings->DirectModeIsDefault);
				
				$_screen->data->SetValue('intAttachmentSizeLimit', ceil($this->_settings->AttachmentSizeLimit / 1024));
				$_screen->data->SetValue('intEnableAttachSizeLimit', $this->_settings->EnableAttachmentSizeLimit);
				
				$_screen->data->SetValue('intMailboxSizeLimit', ceil($this->_settings->MailboxSizeLimit / 1024));
				$_screen->data->SetValue('intEnableMailboxSizeLimit', $this->_settings->EnableMailboxSizeLimit);
				
				$_screen->data->SetValue('intAllowUsersChangeEmailSettings', $this->_settings->AllowUsersChangeEmailSettings);
				$_screen->data->SetValue('intAllowNewUsersRegister', $this->_settings->AllowNewUsersRegister);
				$_screen->data->SetValue('intAllowUsersAddNewAccounts', $this->_settings->AllowUsersAddNewAccounts);
				
				$_charsets =& $this->GetCharsetsList();
				$_charsetsString = '';
				foreach ($_charsets as $_charset) 
				{
					$_selected = ($_charset[0] == $this->_settings->DefaultUserCharset) ? ' selected="selected"' : '';
					$_charsetsString .= '<option value="'.ap_Utils::AttributeQuote($_charset[0]).'"'.$_selected.'>'.ap_Utils::EncodeSpecialXmlChars($_charset[1]).'</option>'.AP_CRLF;
				}
				$_screen->data->SetValue('txtDefaultUserCharset', $_charsetsString);
				$_screen->data->SetValue('intAllowUsersChangeCharset', $this->_settings->AllowUsersChangeCharset);
				
				$_timezones =& $this->GetTimeZoneList();
				$_timezonesString = '';
				foreach ($_timezones as $_timezoneKey => $_timezoneValue) 
				{
					$_selected = ($_timezoneKey == $this->_settings->DefaultTimeZone) ? ' selected="selected"' : '';
					$_timezonesString .= '<option value="'.ap_Utils::AttributeQuote($_timezoneKey).'"'.$_selected.'>'.ap_Utils::EncodeSpecialXmlChars($_timezoneValue).'</option>'.AP_CRLF;
				}
				$_screen->data->SetValue('txtDefaultTimeZone', $_timezonesString);
				$_screen->data->SetValue('intAllowUsersChangeTimeZone', $this->_settings->AllowUsersChangeTimeZone);

				/* interface */
				$_screen->data->SetValue('intMailsPerPage', $this->_settings->MailsPerPage);
				
				$_skins =& $this->GetSkinsList();
				$_skinsString = '';
				foreach ($_skins as $_skin) 
				{
					$_selected = ($_skin == $this->_settings->DefaultSkin) ? ' selected="selected"' : '';
					$_skinsString .= '<option value="'.ap_Utils::AttributeQuote($_skin).'"'.$_selected.'>'.ap_Utils::EncodeSpecialXmlChars($_skin).'</option>'.AP_CRLF;
				}
				$_screen->data->SetValue('txtDefaultSkin', $_skinsString);
				$_screen->data->SetValue('intAllowUsersChangeSkin', $this->_settings->AllowUsersChangeSkin);
				

				$_langs =& $this->GetLangsList();
				$_langsString = '';
				foreach ($_langs as $_lang) 
				{
					$_selected = ($_lang == $this->_settings->DefaultLanguage) ? ' selected="selected"' : '';
					$_langsString .= '<option value="'.ap_Utils::AttributeQuote($_lang).'"'.$_selected.'>'.ap_Utils::EncodeSpecialXmlChars($_lang).'</option>'.AP_CRLF;
				}
				$_screen->data->SetValue('txtDefaultLanguage', $_langsString);
				$_screen->data->SetValue('intAllowUsersChangeLanguage', $this->_settings->AllowUsersChangeLanguage);
				
				$_screen->data->SetValue('intShowTextLabels', $this->_settings->ShowTextLabels);
				$_screen->data->SetValue('intAllowAjaxVersion', $this->_settings->AllowAjax);
				$_screen->data->SetValue('intAllowDHTMLEditor', $this->_settings->AllowDhtmlEditor);
				$_screen->data->SetValue('intAllowContacts', $this->_settings->AllowContacts);
				$_screen->data->SetValue('intAllowCalendar', $this->_settings->AllowCalendar);
				
				/* login */
				$_hlm = (string) $this->_settings->HideLoginMode;
				$_hlm_len = strlen($_hlm);
				if ($_hlm_len > 0)
				{
					switch ($_hlm{0})
					{
						case '0':
							$_screen->data->SetValue('hideLoginRadionButton1', true);
							break;
						case '1':
							$_screen->data->SetValue('hideLoginRadionButton2', true);
							if ($_hlm_len > 1)
							{
								switch ($_hlm{1})
								{
									case '0':
										$_screen->data->SetValue('hideLoginSelect0', true);
										break;
									case '1':
										$_screen->data->SetValue('hideLoginSelect1', true);
										break;
								}
							}							
							break;
						case '2':
							$_screen->data->SetValue('hideLoginRadionButton3', true);
							if ($_hlm_len > 1)
							{
								switch ($_hlm{1})
								{
									case '1':
										$_screen->data->SetValue('intDisplayDomainAfterLoginField', true);
										break;
									case '2':
										$_screen->data->SetValue('intLoginAsConcatination', true);
										break;
									case '3':
										$_screen->data->SetValue('intDisplayDomainAfterLoginField', true);
										$_screen->data->SetValue('intLoginAsConcatination', true);
										break;
								}
							}
							break;
					}
				}
				
				$_screen->data->SetValue('txtUseDomain', $this->_settings->DefaultDomainOptional);
				$_screen->data->SetValue('intAllowAdvancedLogin', $this->_settings->AllowAdvancedLogin);
				$_screen->data->SetValue('intAutomaticHideLogin', $this->_settings->AutomaticCorrectLoginSettings);
				
				/* cal */
				$_screen->data->SetValue('defTimeFormat0', ($this->_settings->Cal_DefaultTimeFormat == 1));
				$_screen->data->SetValue('defTimeFormat1', ($this->_settings->Cal_DefaultTimeFormat == 2));
				
				$_timestamp = time();
				if ((int) date('m', $_timestamp) == (int) date('d', $_timestamp))
				{
					$_timestamp += 86400;
				}
				
				$_screen->data->SetValue('defDateFormatValue1', date('m/d/Y', $_timestamp));
				$_screen->data->SetValue('defDateFormatValue2', date('d/m/Y', $_timestamp));
				$_screen->data->SetValue('defDateFormatValue3', date('Y-m-d', $_timestamp));
				$_screen->data->SetValue('defDateFormatValue4', date('M d, Y', $_timestamp));
				$_screen->data->SetValue('defDateFormatValue5', date('d M Y', $_timestamp));
				
				switch ($this->_settings->Cal_DefaultDateFormat)
				{
					case 1: $_screen->data->SetValue('defDateFormat1', true); break;
					case 2: $_screen->data->SetValue('defDateFormat2', true); break;
					case 3: $_screen->data->SetValue('defDateFormat3', true); break;
					case 4: $_screen->data->SetValue('defDateFormat4', true); break;
					case 5: $_screen->data->SetValue('defDateFormat5', true); break;
				}

				$_screen->data->SetValue('showWeekends', $this->_settings->Cal_ShowWeekends);
				$_screen->data->SetValue('showWorkDay', $this->_settings->Cal_ShowWorkDay);
				
				switch ($this->_settings->Cal_WeekStartsOn)
				{
					case 0: $_screen->data->SetValue('weekStartsOn0', true); break;
					case 1: $_screen->data->SetValue('weekStartsOn1', true); break;
				}

				switch ($this->_settings->Cal_DefaultTab)
				{
					case 1: $_screen->data->SetValue('defTab1', true); break;
					case 2: $_screen->data->SetValue('defTab2', true); break;
					case 3: $_screen->data->SetValue('defTab3', true); break;
				}
				
				$_country = '';
				if (@file_exists($this->_settings->_path.'/country/country.dat'))
				{
					$_countryCode = $_countryName = '';
					$_i = 1;
					$_fp = @fopen($this->_settings->_path.'/country/country.dat', 'r');
					if ($_fp)
					{
						while (!feof($_fp))
						{
							$_str = trim(fgets($_fp));
							list($_countryCode, $_countryName) = split ('-', $_str);
							$_country .= '<option value="'.ap_Utils::AttributeQuote($_countryCode).'"';
							if ($this->_settings->Cal_DefaultCountry == $_countryCode)
							{
								$_country .= ' selected="selected"';
							}
							$_country .= '>'.ap_Utils::EncodeSpecialXmlChars($_countryName).'</option>'.AP_CRLF;
							$_i++;
							if ($_i > 300)
							{
								break;
							}
						}
						@fclose($_fp);
					}
				}
				
				$_screen->data->SetValue('Country_dat', $_country);
				
				$_screen->data->SetValue('allTimeZones', $this->_settings->Cal_AllTimeZones);
				
				$_screen->data->SetValue('Cal_WorkdayStarts', $this->_settings->Cal_WorkdayStarts);
				$_screen->data->SetValue('Cal_WorkdayEnds', $this->_settings->Cal_WorkdayEnds);
				$_screen->data->SetValue('Cal_DefaultTimeFormat', $this->_settings->Cal_DefaultTimeFormat);
				$_screen->data->SetValue('Cal_DefaultTimeZone', $this->_settings->Cal_DefaultTimeZone);
				$_screen->data->SetValue('CheckWorkdayTimeError', ap_Utils::TakePhrase('WM_INFO_CAL_CHECKWORKDAYTIMEERROR'));
			
				/* debug */
				$_fileName =  $this->_settings->_path.'/logs/log_'.date('Y-m-d').'.txt';
				
				$_screen->data->SetValue('intEnableLogging', $this->_settings->EnableLogging);
				$_screen->data->SetValue('txtPathForLog', $_fileName);
					
				$_size = 0;
				if (file_exists($_fileName))
				{
					$_size = filesize($_fileName);
				}
				$_size = ap_Utils::GetFriendlySize($_size);
				$_screen->data->SetValue('txtLogSize', $_size);
				
				/* integration */
				$_screen->data->SetValue('intEnableWmServer', $this->_settings->EnableWmServer);
				$_screen->data->SetValue('txtWmServerRootPath', $this->_settings->WmServerRootPath);
				$_screen->data->SetValue('txtWmServerHostName', $this->_settings->WmServerHost);
				$_screen->data->SetValue('intWmAllowManageXMailAccounts', $this->_settings->WmAllowManageXMailAccounts);
			}
			else
			{
				$this->_setError(ap_Utils::TakePhrase('WM_INFO_CANTLOAD_SETTINGS'));;
			}
		}
		
		/**
		 * @param	Account	$account
		 * @param	int		$synchronize
		 */
		function _updateAccountFromPost(&$_account, &$_synchronize)
		{
			$_account->MailboxSize = 0;
			if (isset($_POST['intLimitMailbox']) && strlen($_POST['intLimitMailbox']) < 7)
			{
				$_account->MailboxLimit = round(((int) $_POST['intLimitMailbox']) * 1024);
			}
			
			if (isset($_POST['MaxMailboxSize']) && strlen($_POST['MaxMailboxSize']) < 7)
			{
				$_account->MailboxLimit = round(((int) $_POST['MaxMailboxSize']) * 1024);
			}
						
			$_account->FriendlyName = isset($_POST['txtFriendlyName']) ? $_POST['txtFriendlyName'] : $_account->FriendlyName;
		
			$_account->Email = isset($_POST['txtEmail']) ? strtolower($_POST['txtEmail']) : $_account->Email;
			
			if ($_account->DomainId === 0)
			{
				$_account->MailIncHost = isset($_POST['txtIncomingMail']) ? $_POST['txtIncomingMail'] : $_account->MailIncHost;
				$_account->MailIncPort = isset($_POST['intIncomingPort']) ? (int) $_POST['intIncomingPort'] : $_account->MailIncPort;
				$_account->MailOutHost = isset($_POST['txtSmtpServer']) ? $_POST['txtSmtpServer'] : $_account->MailOutHost;			
				$_account->MailOutPort = isset($_POST['intSmtpPort']) ? (int) $_POST['intSmtpPort'] : $_account->MailOutPort;			
			}	
			$_account->MailIncLogin = isset($_POST['txtIncomingLogin']) ? $_POST['txtIncomingLogin'] : $_account->MailIncLogin;
			
			$_password = isset($_POST['txtIncomingPassword']) ? $_POST['txtIncomingPassword'] : AP_DUMMYPASSWORD;
			if ($_password != AP_DUMMYPASSWORD)
			{
				$_account->MailIncPassword = $_password; 
			}
			
			$_password = isset($_POST['UserPassword_PassMode']) ? $_POST['UserPassword_PassMode'] : AP_DUMMYPASSWORD;
			if ($_password != AP_DUMMYPASSWORD)
			{
				$_account->MailIncPassword = $_password; 
			}
			
			$_account->MailOutLogin = isset($_POST['txtSmtpLogin']) ? $_POST['txtSmtpLogin'] : $_account->MailOutLogin;
			
			$_password = isset($_POST['txtSmtpPassword']) ? $_POST['txtSmtpPassword'] : AP_DUMMYPASSWORD;
			if ($_password != AP_DUMMYPASSWORD)
			{
				$_account->MailOutPassword = $_password; 
			}
			
			$_protocol = isset($_POST['intMailProtocol']) ? $_POST['intMailProtocol'] : WM_MAILPROTOCOL_POP3;
			switch ($_protocol)
			{
				default:
					$_account->MailProtocol = WM_MAILPROTOCOL_POP3;
					break;
				case WM_MAILPROTOCOL_POP3:
				case WM_MAILPROTOCOL_IMAP4:
				case WM_MAILPROTOCOL_WMSERVER:
					$_account->MailProtocol = (int) $_protocol;
					break;
			}

			if ($_account->DomainId === 0)
			{
				$_account->MailOutAuthentication = (isset($_POST['chkUseSmtpAuth']));
			}
			
			$_account->UseFriendlyName = (isset($_POST['chkUseFriendlyName']));
			$_account->GetMailAtLogin = (isset($_POST['chkGetMailAtLogin']));
			if ($_account->MailProtocol !== WM_MAILPROTOCOL_WMSERVER)
			{
				$_account->AllowDirectMode = (isset($_POST['chkAllowDM']));
			}
			$_account->AllowChangeSettings = (isset($_POST['chkAllowChangeEmail']));
			
			if (isset($_POST['synchronizeSelect']) && $_account->MailProtocol == WM_MAILPROTOCOL_POP3)
			{
				$_synchronize = (int) $_POST['synchronizeSelect'];
			}
			else
			{
				$_synchronize = ($_account->MailProtocol == WM_MAILPROTOCOL_POP3) ? WM_FOLDERSYNC_AllEntireMessages : WM_FOLDERSYNC_AllHeadersOnly;
			}

			if ($_account->MailProtocol === WM_MAILPROTOCOL_POP3)
			{
				$_account->MailsOnServerDays = isset($_POST['txtKeepMsgsDays']) ? (int) $_POST['txtKeepMsgsDays'] : $_account->MailsOnServerDays;
				
				if (isset($_POST['chkDelMsgsDB']))
				{
					if ($_synchronize == WM_FOLDERSYNC_NewHeadersOnly || $_synchronize == WM_FOLDERSYNC_NewEntireMessages)
					{
						$_synchronize++;
					}
				}
				
				$_mailmode = WM_MAILMODE_LeaveMessagesOnServer;
				
				if (isset($_POST['mailMode']))
				{
					if ((int) $_POST['mailMode'] == 1)
					{
						$_mailmode = WM_MAILMODE_DeleteMessagesFromServer;
					}
					else 
					{
						$_p = 0;
						if (isset($_POST['chkKeepMsgs']))
						{
							$_mailmode = WM_MAILMODE_KeepMessagesOnServer;
							$_p++;
						}
						if (isset($_POST['chkDelMsgsSrv']))
						{
							$_mailmode = WM_MAILMODE_DeleteMessageWhenItsRemovedFromTrash;
							$_p++;
						}
						if ($_p == 2)
						{
							$_mailmode = WM_MAILMODE_KeepMessagesOnServerAndDeleteMessageWhenItsRemovedFromTrash;
						}
					}
				}
				
				$_account->MailMode = $_mailmode;
			}
		}
		
		/**
		 * @param ap_Screen_Data $data
		 * @param Account $account
		 */		
		function _updateScreenDataFromDomain(&$_data, &$_domain)
		{
			$_data->SetValue('DomainName', $_domain->_name);
			$_data->SetValue('txtIncomingMail', $_domain->_mailIncomingHost);
			$_data->SetValue('intIncomingMailPort', $_domain->_mailIncomingPort);
			$_data->SetValue('txtOutgoingMail', $_domain->_mailSmtpHost);
			$_data->SetValue('intOutgoingMailPort', $_domain->_mailSmtpPort);
			$_data->SetValue('intReqSmtpAuthentication', $_domain->_mailSmtpAuth);
			if ($_domain->_mailProtocol === WM_MAILPROTOCOL_IMAP4)
			{
				$_data->SetValue('intIncomingMailProtocolIMAP4', true);
			}
			else
			{
				$_data->SetValue('intIncomingMailProtocolPOP3', true);
			}
		}
		
		/**
		 * @param ap_Screen_Data $data
		 * @param Account $account
		 */
		function _updateScreenDataFromAccount(&$_data, &$_account, $_isNewAccount = false)
		{
			$_data->SetValue('txtIncomingLogin', $_account->MailIncLogin);
			if (!$_isNewAccount)
			{
				if (strlen($_account->MailIncPassword) > 0)
				{
					$_data->SetValue('txtIncomingPassword', AP_DUMMYPASSWORD);
				}
				
				if (strlen($_account->MailOutPassword) > 0)
				{
					$_data->SetValue('txtSmtpPassword', AP_DUMMYPASSWORD);
				}
			}
			
			$_data->SetValue('selectMailProtocolPop3', ($_account->MailProtocol == WM_MAILPROTOCOL_POP3));
			$_data->SetValue('selectMailProtocolImap4', ($_account->MailProtocol == WM_MAILPROTOCOL_IMAP4));
			
			$_data->SetValue('txtIncomingMail', $_account->MailIncHost);
			$_data->SetValue('txtSmtpServer', $_account->MailOutHost);
			
			$_data->SetValue('intIncomingPort', (int) $_account->MailIncPort);
			$_data->SetValue('intSmtpPort', (int) $_account->MailOutPort);
			
			$_data->SetValue('intLimitMailbox', (int) ceil($_account->MailboxLimit / 1024));
			$_data->SetValue('txtFriendlyName', $_account->FriendlyName);
			$_data->SetValue('txtEmail', $_account->Email);
			
			$_data->SetValue('txtSmtpLogin', $_account->MailOutLogin);
			$_data->SetValue('txtKeepMsgsDays', $_account->MailsOnServerDays);
			
			$_data->SetValue('chkUseSmtpAuth', $_account->MailOutAuthentication);
			$_data->SetValue('chkUseFriendlyName', $_account->UseFriendlyName);
			
			$_data->SetValue('chkGetMailAtLogin', $_account->GetMailAtLogin);
			$_data->SetValue('chkAllowDM', $_account->AllowDirectMode);
			$_data->SetValue('chkAllowChangeEmail', $_account->AllowChangeSettings);
			
			if ($_account->MailProtocol == WM_MAILPROTOCOL_POP3)
			{
				switch ($_account->MailMode)
				{
					case WM_MAILMODE_DeleteMessagesFromServer:
						$_data->SetValue('radioDelRecvMsgs', true);
						break;
					case WM_MAILMODE_LeaveMessagesOnServer:
						$_data->SetValue('radioLeaveMsgs', true);
						break;
					case WM_MAILMODE_KeepMessagesOnServer:
						$_data->SetValue('radioLeaveMsgs', true);
						$_data->SetValue('chkKeepMsgs', true);
						break;
					case WM_MAILMODE_DeleteMessageWhenItsRemovedFromTrash:
						$_data->SetValue('radioLeaveMsgs', true);
						$_data->SetValue('chkDelMsgsSrv', true);
						break;
					case WM_MAILMODE_KeepMessagesOnServerAndDeleteMessageWhenItsRemovedFromTrash:
						$_data->SetValue('radioLeaveMsgs', true);
						$_data->SetValue('chkKeepMsgs', true);
						$_data->SetValue('chkDelMsgsSrv', true);
						break;
				}
				
				$_folderSyncType = $_data->GetValueAsInt('folderSyncType');
				if ($_folderSyncType == WM_FOLDERSYNC_NewHeadersOnly || $_folderSyncType == WM_FOLDERSYNC_AllHeadersOnly)
				{
					$_data->SetValue('synchronizeSelect1', true);
				}
				else if ($_folderSyncType == WM_FOLDERSYNC_DirectMode)
				{
					$_data->SetValue('synchronizeSelect5', true);
				}
				else
				{
					$_data->SetValue('synchronizeSelect3', true);
				}
				
				if ($_folderSyncType == WM_FOLDERSYNC_AllHeadersOnly || $_folderSyncType == WM_FOLDERSYNC_AllEntireMessages)
				{
					$_data->SetValue('chkDelMsgsDB', true);
				}
			}
		}
		
		/**
		 * @return	Array
		 */
		function &GetSkinsList()
		{
			$_skinsList = array();
			$_dir = $this->_settings->_webpath.'/skins';
			if (is_dir($_dir))
			{
				$_dh = @opendir($_dir);
				if ($_dh)
				{
					while (($_file = readdir($_dh)) !== false)
					{
						if (strlen($_file) > 0 && $_file{0} != '.' && file_exists($this->_settings->_webpath.'/skins/'.$_file.'/styles.css'))
						{
							$_skinsList[] = $_file; 
						}
					}
					@closedir($_dh);
				}
			}
			return $_skinsList;
		}
		
		/**
		 * @return Array
		 */
		function &GetLangsList()
		{
			$_langsList = array();
			$_dir = $this->_settings->_webpath.'/lang';
			if (is_dir($_dir))
			{
				$_dh = @opendir($_dir);
				if ($_dh)
				{
					while (($_file = readdir($_dh)) !== false)
					{
						if (is_file($this->_settings->_webpath.'/lang/'.$_file) && strpos($_file, '.php') !== false)
						{
							$_lang = strtolower(substr($_file, 0, -4));
							if ($_lang != 'index' && $_lang != 'default')
							{
								$_langsList[] = substr($_file, 0, -4);
							}
						}
					}
					@closedir($_dh);
				}
			}
			return $_langsList;
		}
		
		/**
		 * @return	array
		 */
		function &GetCharsetsList()
		{
			$_ch = array(
					array('-1', 'Default'),
					array('iso-8859-6', 'Arabic Alphabet (ISO)'),
					array('windows-1256', 'Arabic Alphabet (Windows)'),
					array('iso-8859-4', 'Baltic Alphabet (ISO)'),
					array('windows-1257', 'Baltic Alphabet (Windows)'),
					array('iso-8859-2', 'Central European Alphabet (ISO)'),
					array('windows-1250', 'Central European Alphabet (Windows)'),
					array('euc-cn', 'Chinese Simplified (EUC)'),
					array('gb2312', 'Chinese Simplified (GB2312)'),
					array('big5', 'Chinese Traditional (Big5)'),
					array('iso-8859-5', 'Cyrillic Alphabet (ISO)'),
					array('koi8-r', 'Cyrillic Alphabet (KOI8-R)'),
					array('windows-1251', 'Cyrillic Alphabet (Windows)'),
					array('iso-8859-7', 'Greek Alphabet (ISO)'),
					array('windows-1253', 'Greek Alphabet (Windows)'),
					array('iso-8859-8', 'Hebrew Alphabet (ISO)'),
					array('windows-1255', 'Hebrew Alphabet (Windows)'),
					array('iso-2022-jp', 'Japanese'),
					array('shift-jis', 'Japanese (Shift-JIS)'),
					array('euc-kr', 'Korean (EUC)'),
					array('iso-2022-kr', 'Korean (ISO)'),
					array('iso-8859-3', 'Latin 3 Alphabet (ISO)'),
					array('windows-1254', 'Turkish Alphabet'),
					array('utf-7', 'Universal Alphabet (UTF-7)'),
					array('utf-8', 'Universal Alphabet (UTF-8)'),
					array('windows-1258', 'Vietnamese Alphabet (Windows)'),
					array('iso-8859-1', 'Western Alphabet (ISO)'),
					array('windows-1252', 'Western Alphabet (Windows)')
				);
				
			return $_ch;
		}
		
		/**
		 * @return	array
		 */
		function &GetTimeZoneList()
		{
			$_tz = array(
					'Default',
					'(GMT -12:00) Eniwetok, Kwajalein, Dateline Time',
					'(GMT -11:00) Midway Island, Samoa',
					'(GMT -10:00) Hawaii',
					'(GMT -09:00) Alaska',
					'(GMT -08:00) Pacific Time (US & Canada); Tijuana',
					'(GMT -07:00) Arizona',
					'(GMT -07:00) Mountain Time (US & Canada)',
					'(GMT -06:00) Central America',
					'(GMT -06:00) Central Time (US & Canada)',
					'(GMT -06:00) Mexico City, Tegucigalpa',
					'(GMT -06:00) Saskatchewan',
					'(GMT -05:00) Indiana (East)',
					'(GMT -05:00) Eastern Time (US & Canada)',
					'(GMT -05:00) Bogota, Lima, Quito',
					'(GMT -04:00) Santiago',
					'(GMT -04:00) Caracas, La Paz',
					'(GMT -04:00) Atlantic Time (Canada)',
					'(GMT -03:30) Newfoundland',
					'(GMT -03:00) Greenland',
					'(GMT -03:00) Buenos Aires, Georgetown',
					'(GMT -03:00) Brasilia',
					'(GMT -02:00) Mid-Atlantic',
					'(GMT -01:00) Cape Verde Is.',
					'(GMT -01:00) Azores',
					'(GMT) Casablanca, Monrovia',
					'(GMT) Dublin, Edinburgh, Lisbon, London',
					'(GMT +01:00) Amsterdam, Berlin, Bern, Rome, Stockholm, Vienna',
					'(GMT +01:00) Belgrade, Bratislava, Budapest, Ljubljana, Prague',
					'(GMT +01:00) Brussels, Copenhagen, Madrid, Paris',
					'(GMT +01:00) Sarajevo, Skopje, Sofija, Vilnius, Warsaw, Zagreb',
					'(GMT +01:00) West Central Africa',
					'(GMT +02:00) Athens, Istanbul, Minsk',
					'(GMT +02:00) Bucharest',
					'(GMT +02:00) Cairo',
					'(GMT +02:00) Harare, Pretoria',
					'(GMT +02:00) Helsinki, Riga, Tallinn',
					'(GMT +02:00) Israel, Jerusalem Standard Time',
					'(GMT +03:00) Baghdad',
					'(GMT +03:00) Arab, Kuwait, Riyadh',
					'(GMT +03:00) Moscow, St. Petersburg, Volgograd',
					'(GMT +03:00) East Africa, Nairobi',
					'(GMT +03:30) Tehran',
					'(GMT +04:00) Abu Dhabi, Muscat',
					'(GMT +04:00) Baku, Tbilisi, Yerevan',
					'(GMT +04:30) Kabul',
					'(GMT +05:00) Ekaterinburg',
					'(GMT +05:00) Islamabad, Karachi, Sverdlovsk, Tashkent',
					'(GMT +05:30) Calcutta, Chennai, Mumbai, New Delhi, India Standard Time',
					'(GMT +05:45) Kathmandu, Nepal',
					'(GMT +06:00) Almaty, Novosibirsk, North Central Asia',
					'(GMT +06:00) Astana, Dhaka',
					'(GMT +06:00) Sri Jayawardenepura, Sri Lanka',
					'(GMT +06:30) Rangoon',
					'(GMT +07:00) Bangkok, Hanoi, Jakarta',
					'(GMT +07:00) Krasnoyarsk',
					'(GMT +08:00) Beijing, Chongqing, Hong Kong SAR, Urumqi',
					'(GMT +08:00) Irkutsk, Ulaan Bataar',
					'(GMT +08:00) Kuala Lumpur, Singapore',
					'(GMT +08:00) Perth, Western Australia',
					'(GMT +08:00) Taipei',
					'(GMT +09:00) Osaka, Sapporo, Tokyo',
					'(GMT +09:00) Seoul, Korea Standard time',
					'(GMT +09:00) Yakutsk',
					'(GMT +09:30) Adelaide, Central Australia',
					'(GMT +09:30) Darwin',
					'(GMT +10:00) Brisbane, East Australia',
					'(GMT +10:00) Canberra, Melbourne, Sydney, Hobart',
					'(GMT +10:00) Guam, Port Moresby',
					'(GMT +10:00) Hobart, Tasmania',
					'(GMT +10:00) Vladivostok',
					'(GMT +11:00) Magadan, Solomon Is., New Caledonia',
					'(GMT +12:00) Auckland, Wellington',
					'(GMT +12:00) Fiji Islands, Kamchatka, Marshall Is.',
					'(GMT +13:00) Nuku\'alofa, Tonga,'
				);
				
			return $_tz;
		}

		/**
		 * @param 	int		$_codePageNum
		 * @return	string
		 */
		function GetCodePageName($_codePageNum)
		{
			static $_mapping = array(
						0 => 'default',
						51936 => 'euc-cn',
						936 => 'gb2312',
						950 => 'big5',
						946 => 'euc-kr',
						50225 => 'iso-2022-kr',
						50220 => 'iso-2022-jp',
						932 => 'shift-jis',
						65000 => 'utf-7',
						65001 => 'utf-8',
						1250 => 'windows-1250',
						1251 => 'windows-1251',
						1252 => 'windows-1252',
						1253 => 'windows-1253',
						1254 => 'windows-1254',
						1255 => 'windows-1255',
						1256 => 'windows-1256',
						1257 => 'windows-1257',
						1258 => 'windows-1258',
						20866 => 'koi8-r',
						28591 => 'iso-8859-1',
						28592 => 'iso-8859-2',
						28593 => 'iso-8859-3',
						28594 => 'iso-8859-4',
						28595 => 'iso-8859-5',
						28596 => 'iso-8859-6',
						28597 => 'iso-8859-7',
						28598 => 'iso-8859-8');

			if (isset($_mapping[$_codePageNum]))
			{
				return $_mapping[$_codePageNum];
			}
			return '';
		}
		
		/**
		 * @param	string	$codePageName
		 * @return	int
		 */
		function GetCodePageNumber($_codePageName)
		{
			static $_mapping = array(
						'default' => 0,
						'euc-cn' => 51936,
						'gb2312' => 936,
						'big5' => 950,
						'euc-kr' => 949,
						'iso-2022-kr' => 50225,
						'iso-2022-jp' => 50220,
						'shift-jis' => 932,
						'utf-7' => 65000,
						'utf-8' => 65001,
						'windows-1250' => 1250,
						'windows-1251' => 1251,
						'windows-1252' => 1252,
						'windows-1253' => 1253,
						'windows-1254' => 1254,
						'windows-1255' => 1255,
						'windows-1256' => 1256,
						'windows-1257' => 1257,
						'windows-1258' => 1258,
						'koi8-r' => 20866,
						'iso-8859-1' => 28591,
						'iso-8859-2' => 28592,
						'iso-8859-3' => 28593,
						'iso-8859-4' => 28594,
						'iso-8859-5' => 28595,
						'iso-8859-6' => 28596,
						'iso-8859-7' => 28597,
						'iso-8859-8' => 28598);
    
			if (isset($_mapping[$_codePageName]))
			{
				return $_mapping[$_codePageName];
			}
			return 0;
		}
	}
	